### This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import sos.plugintools
import os

class apt(sos.plugintools.PluginBase):
    """apt information
    """

    optionList = [("apt", "list repositories and packages", "slow", False)]

    def checkenabled(self):
        if self.cInfo["policy"].pkgByName("yum") or os.path.exists("/etc/apt/apt.conf"):
            return True
        return False

    def diagnose(self):
        # FIXME: diagnose should only report actual problems, disabling this for now.
        return True
        # repo sanity checking
        # TODO: elaborate/validate actual repo files, however this directory should
        # be empty on RHEL 5+ systems.
        #try: rhelver = self.cInfo["policy"].pkgDictByName("redhat-release")[0]
        #except: rhelver = None
        #if rhelver == "5" or True:
        #    if len(os.listdir('/etc/apt/apt.conf.d/')):
        #        self.addDiagnose("/etc/apt.conf.d/ contains additional repository "+
        #                         "information and can cause rpm conflicts.")
	# In Sisyphus
	return True

    def setup(self):
        # Pull all yum related information
        self.addCopySpec("/etc/apt")
        self.addCopySpec("/etc/apt/apt.conf.d")
        self.addCopySpec("/etc/apt/apt.conf")
        self.addCopySpec("/etc/apt/sources.list")
        #if self.isOptionEnabled("yumlist"):
        #    # Get a list of channels the machine is subscribed to.
        #    self.collectExtOutput("/bin/echo \"repo list\" | /usr/bin/yum shell")
        #    # List various information about available packages
        #    self.collectExtOutput("/usr/bin/yum list")
        return True
